Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/HiveService.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/HiveService.cs	(revision 6458)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/HiveService.cs	(revision 6463)
@@ -51,4 +51,7 @@
       get { return ServiceLocator.Instance.LifecycleManager; }
     }
+    private IUserManager userManager {
+      get { return ServiceLocator.Instance.UserManager; }
+    }
     private HeartbeatManager heartbeatManager {
       get { return ServiceLocator.Instance.HeartbeatManager; }
@@ -66,5 +69,5 @@
         }
         dao.AddJobData(jobData);
-        dao.UpdateJobState(job.Id, JobState.Waiting, null, author.UserId, null);
+        dao.UpdateJobState(job.Id, JobState.Waiting, null, userManager.CurrentUserId, null);
         return jobData.JobId;
       }, false, true);
@@ -81,4 +84,5 @@
     public Job GetJob(Guid jobId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
+      author.AuthorizeForJob(jobId, Permission.Read);
       return dao.GetJob(jobId);
     }
@@ -86,19 +90,29 @@
     public IEnumerable<Job> GetJobs() {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
-      return dao.GetJobs(x => true);
+      var jobs = dao.GetJobs(x => true);
+      foreach (var job in jobs)
+        author.AuthorizeForJob(job.Id, Permission.Read);
+      return jobs;
     }
 
     public IEnumerable<LightweightJob> GetLightweightJobs(IEnumerable<Guid> jobIds) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
-      return dao.GetJobs(x => jobIds.Contains(x.JobId)).Select(x => new LightweightJob(x)).ToArray();
+      var jobs = dao.GetJobs(x => jobIds.Contains(x.JobId)).Select(x => new LightweightJob(x)).ToArray();
+      foreach (var job in jobs)
+        author.AuthorizeForJob(job.Id, Permission.Read);
+      return jobs;
     }
 
     public IEnumerable<LightweightJob> GetLightweightChildJobs(Guid? parentJobId, bool recursive, bool includeParent) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
-      return GetChildJobs(parentJobId, recursive, includeParent).Select(x => new LightweightJob(x)).ToArray();
+      var jobs = GetChildJobs(parentJobId, recursive, includeParent).Select(x => new LightweightJob(x)).ToArray();
+      foreach (var job in jobs)
+        author.AuthorizeForJob(job.Id, Permission.Read);
+      return jobs;
     }
 
     public IEnumerable<LightweightJob> GetLightweightExperimentJobs(Guid experimentId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      author.AuthorizeForExperiment(experimentId, Permission.Read);
       return dao.GetJobs(x => x.HiveExperimentId == experimentId).Select(x => new LightweightJob(x)).ToArray();
     }
@@ -106,4 +120,5 @@
     public JobData GetJobData(Guid jobId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
+      author.AuthorizeForJob(jobId, Permission.Read);
       return dao.GetJobData(jobId);
     }
@@ -111,4 +126,5 @@
     public void UpdateJob(Job job) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
+      author.AuthorizeForJob(job.Id, Permission.Full);
       trans.UseTransaction(() => {
         dao.UpdateJob(job);
@@ -118,4 +134,6 @@
     public void UpdateJobData(Job job, JobData jobData) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
+      author.AuthorizeForJob(job.Id, Permission.Full);
+      author.AuthorizeForJob(jobData.JobId, Permission.Full);
       //trans.UseTransaction(() => { // cneumuel: try without transaction
       jobData.LastUpdate = DateTime.Now;
@@ -127,4 +145,5 @@
     public void DeleteJob(Guid jobId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
+      author.AuthorizeForJob(jobId, Permission.Full);
       trans.UseTransaction(() => {
         dao.DeleteJob(jobId);
@@ -134,4 +153,5 @@
     public void DeleteChildJobs(Guid parentJobId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
+      author.AuthorizeForJob(parentJobId, Permission.Full);
       trans.UseTransaction(() => {
         var jobs = GetChildJobs(parentJobId, true, false);
@@ -145,4 +165,5 @@
     public Job UpdateJobState(Guid jobId, JobState jobState, Guid? slaveId, Guid? userId, string exception) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
+      author.AuthorizeForJob(jobId, Permission.Full);
       return trans.UseTransaction(() => {
         Job job = dao.UpdateJobState(jobId, jobState, slaveId, userId, exception);
@@ -166,5 +187,8 @@
     public IEnumerable<Job> GetJobsByResourceId(Guid resourceId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator);
-      return trans.UseTransaction(() => dao.GetJobsByResourceId(resourceId));
+      var jobs = trans.UseTransaction(() => dao.GetJobsByResourceId(resourceId));
+      foreach(var job in jobs)
+        author.AuthorizeForJob(job.Id, Permission.Read);
+      return jobs;
     }
     #endregion
@@ -173,4 +197,5 @@
     public void StopJob(Guid jobId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
+      author.AuthorizeForJob(jobId, Permission.Full);
       trans.UseTransaction(() => {
         var job = dao.GetJob(jobId);
@@ -188,4 +213,5 @@
     public void PauseJob(Guid jobId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
+      author.AuthorizeForJob(jobId, Permission.Full);
       trans.UseTransaction(() => {
         var job = dao.GetJob(jobId);
@@ -201,6 +227,7 @@
     public void RestartJob(Guid jobId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
-      trans.UseTransaction(() => {
-        Job job = dao.UpdateJobState(jobId, JobState.Waiting, null, author.UserId, string.Empty);
+      author.AuthorizeForJob(jobId, Permission.Full);
+      trans.UseTransaction(() => {
+        Job job = dao.UpdateJobState(jobId, JobState.Waiting, null, userManager.CurrentUserId, string.Empty);
         job.Command = null;
         dao.UpdateJob(job);
@@ -212,9 +239,10 @@
     public HiveExperiment GetHiveExperiment(Guid id) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      author.AuthorizeForExperiment(id, Permission.Read);
       var hiveExperiment = dao.GetHiveExperiments(x =>
             x.HiveExperimentId == id
-            && (x.OwnerUserId == author.UserId || x.HiveExperimentPermissions.Count(hep => hep.Permission != Permission.NotAllowed && hep.GrantedUserId == author.UserId) > 0)
+            && (x.OwnerUserId == userManager.CurrentUserId || x.HiveExperimentPermissions.Count(hep => hep.Permission != Permission.NotAllowed && hep.GrantedUserId == userManager.CurrentUserId) > 0)
           ).FirstOrDefault();
-      if (hiveExperiment != null) hiveExperiment.Permission = dao.GetPermissionForExperiment(hiveExperiment.Id, author.UserId);
+      if (hiveExperiment != null) hiveExperiment.Permission = dao.GetPermissionForExperiment(hiveExperiment.Id, userManager.CurrentUserId);
       return hiveExperiment;
     }
@@ -222,7 +250,9 @@
     public IEnumerable<HiveExperiment> GetHiveExperiments() {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
-      var hiveExperiments = dao.GetHiveExperiments(x => x.OwnerUserId == author.UserId || x.HiveExperimentPermissions.Count(hep => hep.Permission != Permission.NotAllowed && hep.GrantedUserId == author.UserId) > 0);
-      foreach (var he in hiveExperiments)
-        he.Permission = dao.GetPermissionForExperiment(he.Id, author.UserId);
+      var hiveExperiments = dao.GetHiveExperiments(x => x.OwnerUserId == userManager.CurrentUserId || x.HiveExperimentPermissions.Count(hep => hep.Permission != Permission.NotAllowed && hep.GrantedUserId == userManager.CurrentUserId) > 0);
+      foreach (var he in hiveExperiments) {
+        author.AuthorizeForExperiment(he.Id, Permission.Read);
+        he.Permission = dao.GetPermissionForExperiment(he.Id, userManager.CurrentUserId);
+      }
       return hiveExperiments;
     }
@@ -231,6 +261,6 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator);
       var hiveExperiments = dao.GetHiveExperiments(x => true);
-      foreach (var he in hiveExperiments)
-        he.Permission = dao.GetPermissionForExperiment(he.Id, author.UserId);
+      foreach (var he in hiveExperiments) // no authorization here, since this method is admin-only! (admin is allowed to read all jobs)
+        he.Permission = dao.GetPermissionForExperiment(he.Id, userManager.CurrentUserId);
       return hiveExperiments;
     }
@@ -239,5 +269,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       return trans.UseTransaction(() => {
-        hiveExperimentDto.OwnerUserId = author.UserId;
+        hiveExperimentDto.OwnerUserId = userManager.CurrentUserId;
         hiveExperimentDto.DateCreated = DateTime.Now;
         return dao.AddHiveExperiment(hiveExperimentDto);
@@ -247,4 +277,5 @@
     public void UpdateHiveExperiment(HiveExperiment hiveExperimentDto) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      author.AuthorizeForExperiment(hiveExperimentDto.Id, Permission.Full);
       trans.UseTransaction(() => {
         dao.UpdateHiveExperiment(hiveExperimentDto);
@@ -254,4 +285,5 @@
     public void DeleteHiveExperiment(Guid hiveExperimentId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      author.AuthorizeForExperiment(hiveExperimentId, Permission.Full);
       trans.UseTransaction(() => {
         HiveExperiment he = dao.GetHiveExperiment(hiveExperimentId);
@@ -267,7 +299,7 @@
         HiveExperiment he = dao.GetHiveExperiment(hiveExperimentId);
         if (he == null) throw new FaultException<FaultReason>(new FaultReason("Could not find hiveExperiment with id " + hiveExperimentId));
-        Permission perm = dao.GetPermissionForExperiment(he.Id, author.UserId);
+        Permission perm = dao.GetPermissionForExperiment(he.Id, userManager.CurrentUserId);
         if (perm != Permission.Full) throw new FaultException<FaultReason>(new FaultReason("Not allowed to grant permissions for this experiment"));
-        dao.SetHiveExperimentPermission(hiveExperimentId, author.UserId, grantedUserId, permission);
+        dao.SetHiveExperimentPermission(hiveExperimentId, userManager.CurrentUserId, grantedUserId, permission);
       });
     }
@@ -278,7 +310,15 @@
         HiveExperiment he = dao.GetHiveExperiment(hiveExperimentId);
         if (he == null) throw new FaultException<FaultReason>(new FaultReason("Could not find hiveExperiment with id " + hiveExperimentId));
-        Permission perm = dao.GetPermissionForExperiment(he.Id, author.UserId);
+        Permission perm = dao.GetPermissionForExperiment(he.Id, userManager.CurrentUserId);
         if (perm != Permission.Full) throw new FaultException<FaultReason>(new FaultReason("Not allowed to grant permissions for this experiment"));
-        dao.SetHiveExperimentPermission(hiveExperimentId, author.UserId, grantedUserId, Permission.NotAllowed);
+        dao.SetHiveExperimentPermission(hiveExperimentId, userManager.CurrentUserId, grantedUserId, Permission.NotAllowed);
+      });
+    }
+    public IEnumerable<HiveExperimentPermission> GetHiveExperimentPermissions(Guid hiveExperimentId) {
+      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      return trans.UseTransaction(() => {
+        Permission currentUserPermission = dao.GetPermissionForExperiment(hiveExperimentId, userManager.CurrentUserId);
+        if (currentUserPermission != Permission.Full) throw new FaultException<FaultReason>(new FaultReason("Not allowed to list permissions for this experiment"));
+        return dao.GetHiveExperimentPermissions(x => x.HiveExperimentId == hiveExperimentId);
       });
     }
@@ -341,5 +381,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       return trans.UseTransaction(() => {
-        plugin.UserId = author.UserId;
+        plugin.UserId = userManager.CurrentUserId;
         plugin.DateCreated = DateTime.Now;
 
@@ -369,4 +409,6 @@
     }
 
+    // note: this is a possible security problem, since a client is able to download all plugins, which may contain proprietary code (which can be disassembled)
+    //       change so that only with GetPluginByHash it is possible to download plugins
     public IEnumerable<Plugin> GetPlugins() {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
@@ -376,6 +418,5 @@
     public IEnumerable<PluginData> GetPluginDatas(List<Guid> pluginIds) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
-      List<PluginData> pluginDatas = new List<PluginData>();
-
+      var pluginDatas = new List<PluginData>();
       return trans.UseTransaction(() => {
         foreach (Guid guid in pluginIds) {
@@ -394,35 +435,35 @@
     #region Slave Methods
     public Guid AddSlave(Slave slave) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      authen.AuthenticateForAnyRole(HiveRoles.Administrator);
       return trans.UseTransaction(() => dao.AddSlave(slave));
     }
 
     public Guid AddSlaveGroup(SlaveGroup slaveGroup) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      authen.AuthenticateForAnyRole(HiveRoles.Administrator);
       return trans.UseTransaction(() => dao.AddSlaveGroup(slaveGroup));
     }
 
     public Slave GetSlave(Guid slaveId) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      authen.AuthenticateForAnyRole(HiveRoles.Administrator);
       return dao.GetSlave(slaveId);
     }
 
     public SlaveGroup GetSlaveGroup(Guid slaveGroupId) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      authen.AuthenticateForAnyRole(HiveRoles.Administrator);
       return dao.GetSlaveGroup(slaveGroupId);
     }
 
     public IEnumerable<Slave> GetSlaves() {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      authen.AuthenticateForAnyRole(HiveRoles.Administrator);
       return dao.GetSlaves(x => true);
     }
 
     public IEnumerable<SlaveGroup> GetSlaveGroups() {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      authen.AuthenticateForAnyRole(HiveRoles.Administrator);
       return dao.GetSlaveGroups(x => true);
     }
 
     public void UpdateSlave(Slave slave) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      authen.AuthenticateForAnyRole(HiveRoles.Administrator);
       trans.UseTransaction(() => {
         dao.UpdateSlave(slave);
@@ -431,5 +472,5 @@
 
     public void UpdateSlaveGroup(SlaveGroup slaveGroup) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      authen.AuthenticateForAnyRole(HiveRoles.Administrator);
       trans.UseTransaction(() => {
         dao.UpdateSlaveGroup(slaveGroup);
@@ -438,5 +479,5 @@
 
     public void DeleteSlave(Guid slaveId) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      authen.AuthenticateForAnyRole(HiveRoles.Administrator);
       trans.UseTransaction(() => {
         dao.DeleteSlave(slaveId);
@@ -445,5 +486,5 @@
 
     public void DeleteSlaveGroup(Guid slaveGroupId) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      authen.AuthenticateForAnyRole(HiveRoles.Administrator);
       trans.UseTransaction(() => {
         dao.DeleteSlaveGroup(slaveGroupId);
@@ -452,5 +493,5 @@
 
     public void AddResourceToGroup(Guid slaveGroupId, Guid resourceId) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      authen.AuthenticateForAnyRole(HiveRoles.Administrator);
       trans.UseTransaction(() => {
         var resource = dao.GetResource(resourceId);
@@ -461,5 +502,5 @@
 
     public void RemoveResourceFromGroup(Guid slaveGroupId, Guid resourceId) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      authen.AuthenticateForAnyRole(HiveRoles.Administrator);
       trans.UseTransaction(() => {
         var resource = dao.GetResource(resourceId);
@@ -470,5 +511,5 @@
 
     public Guid GetResourceId(string resourceName) {
-      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      authen.AuthenticateForAnyRole(HiveRoles.Administrator);
       return trans.UseTransaction(() => {
         var resource = dao.GetResources(x => x.Name == resourceName).FirstOrDefault();
@@ -482,4 +523,5 @@
 
     public void TriggerLifecycle(bool force) {
+      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Slave);
       // use a serializable transaction here to ensure not two threads execute this simultaniously (mutex-lock would not work since IIS may use multiple AppDomains)
       trans.UseTransaction(() => {
@@ -519,4 +561,21 @@
     #endregion
 
+    #region User Methods
+    public string GetUsernameByUserId(Guid userId) {
+      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      var user = ServiceLocator.Instance.UserManager.GetUserById(userId);
+      if (user != null)
+        return user.UserName;
+      else
+        return null;
+    }
+
+    public Guid GetUserIdByUsername(string username) {
+      authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
+      var user = ServiceLocator.Instance.UserManager.GetUserByName(username);
+      return user != null ? (Guid)user.ProviderUserKey : Guid.Empty;
+    }
+    #endregion
+
     #region Helper Methods
     private IEnumerable<Job> GetChildJobs(Guid? parentJobId, bool recursive, bool includeParent) {
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Interfaces/IAuthorizationManager.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Interfaces/IAuthorizationManager.cs	(revision 6458)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Interfaces/IAuthorizationManager.cs	(revision 6463)
@@ -21,15 +21,15 @@
 
 using System;
+using HeuristicLab.Services.Hive.Common.DataTransfer;
 namespace HeuristicLab.Services.Hive {
   public interface IAuthorizationManager {
-    /// <summary>
-    /// Returns the UserId of the currently authenticated user
-    /// </summary>
-    Guid UserId { get; }
-
     /// <summary>
     /// Compares the current UserId with the given userId and takes appropriate actions if the mismatch
     /// </summary>
     void Authorize(Guid userId);
+
+    void AuthorizeForJob(Guid jobId, Permission requiredPermission);
+
+    void AuthorizeForExperiment(Guid experimentId, Permission requiredPermission);
   }
 }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Interfaces/IServiceLocator.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Interfaces/IServiceLocator.cs	(revision 6458)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Interfaces/IServiceLocator.cs	(revision 6463)
@@ -29,4 +29,5 @@
     ILifecycleManager LifecycleManager { get; }
     ITransactionManager TransactionManager { get; }
+    IUserManager UserManager { get; }
     HeartbeatManager HeartbeatManager { get; }
   }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Interfaces/IUserManager.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Interfaces/IUserManager.cs	(revision 6463)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Interfaces/IUserManager.cs	(revision 6463)
@@ -0,0 +1,32 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Web.Security;
+
+namespace HeuristicLab.Services.Hive {
+  public interface IUserManager {
+    MembershipUser CurrentUser { get; }
+    Guid CurrentUserId { get; }
+    MembershipUser GetUserByName(string username);
+    MembershipUser GetUserById(Guid userId);
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Manager/AuthenticationManager.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Manager/AuthenticationManager.cs	(revision 6463)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Manager/AuthenticationManager.cs	(revision 6463)
@@ -0,0 +1,46 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using System.Security.Authentication;
+using System.Web.Security;
+
+namespace HeuristicLab.Services.Hive {
+  public class AuthenticationManager : HeuristicLab.Services.Hive.IAuthenticationManager {
+    public bool IsInRole(string role) {
+      return Roles.IsUserInRole(role);
+    }
+    public bool IsInAnyRole(params string[] roles) {
+      return roles.Any(x => Roles.IsUserInRole(x));
+    }
+    public bool IsInAllRoles(params string[] roles) {
+      return roles.All(x => Roles.IsUserInRole(x));
+    }
+    public void AuthenticateForAnyRole(params string[] roles) {
+      if (!IsInAnyRole(roles))
+        throw new AuthenticationException("Could not authenticate user for any role required.");
+    }
+    public void AuthenticateForAllRoles(params string[] roles) {
+      if (!IsInAllRoles(roles))
+        throw new AuthenticationException("Could not authenticate user for all roles required.");
+    }
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Manager/AuthorizationManager.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Manager/AuthorizationManager.cs	(revision 6463)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/Manager/AuthorizationManager.cs	(revision 6463)
@@ -0,0 +1,47 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Security;
+using HeuristicLab.Services.Hive.Common.DataTransfer;
+
+namespace HeuristicLab.Services.Hive {
+  public class AuthorizationManager : IAuthorizationManager {
+    public void Authorize(Guid userId) {
+      if (userId != ServiceLocator.Instance.UserManager.CurrentUserId)
+        throw new SecurityException("Current user is not authorized to access object");
+    }
+
+    public void AuthorizeForJob(Guid jobId, Permission requiredPermission) {
+      if (ServiceLocator.Instance.AuthenticationManager.IsInRole(HiveRoles.Slave)) return; // slave-users can access all jobs
+
+      Permission permission = ServiceLocator.Instance.HiveDao.GetPermissionForJob(jobId, ServiceLocator.Instance.UserManager.CurrentUserId);
+      if (permission == Permission.NotAllowed || (permission != requiredPermission && requiredPermission == Permission.Full))
+        throw new SecurityException("Current user is not authorized to access job");
+    }
+
+    public void AuthorizeForExperiment(Guid experimentId, Permission requiredPermission) {
+      Permission permission = ServiceLocator.Instance.HiveDao.GetPermissionForExperiment(experimentId, ServiceLocator.Instance.UserManager.CurrentUserId);
+      if (permission == Permission.NotAllowed || (permission != requiredPermission && requiredPermission == Permission.Full)) 
+        throw new SecurityException("Current user is not authorized to access experiment");
+    }
+  }
+}
